/*
    Sets the frequency of the TV tuner.
    Copyright (C) 2006  Andrew Miller

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define __user
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include <linux/videodev2.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

int
main(int argc, char** argv)
{
  struct v4l2_frequency f_get;
  struct v4l2_capability cap;
  int fd, returnCode;

  fd = open("/dev/video1", O_RDWR);
  if (fd == -1)
  {
    perror("open radio");
    return -1;
  }

  ioctl(fd, VIDIOC_QUERYCAP, &cap);
  printf("Device capability flags: %x\n", cap.capabilities);

  returnCode = ioctl(fd, VIDIOC_G_FREQUENCY, &f_get);
  printf("VIDIOC_G_FREQUENCY returned with code %d\n",returnCode);
  printf("Frequency is currently %.4f MHz and subcarrier is %d kHz\n",(f_get.frequency/16.0),f_get.reserved[0]);

  close(fd);
  return 0;
}
